/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.profilingexample;

/**
 *
 * @author omozegieaziegbe
 */
import java.io.IOException;
import java.lang.management.ManagementFactory;
import com.sun.management.HotSpotDiagnosticMXBean;

public class HeapDumpUtility {

    private static final String HOTSPOT_BEAN_NAME = "com.sun.management:type=HotSpotDiagnostic";
    private static volatile HotSpotDiagnosticMXBean hotspotMBean;

    public static void dumpHeap(String filename, boolean live) throws IOException {
        initHotspotMBean();
        hotspotMBean.dumpHeap(filename, live);
    }

    private static void initHotspotMBean() throws IOException {
        if (hotspotMBean == null) {
            synchronized (HeapDumpUtility.class) {
                hotspotMBean = ManagementFactory.newPlatformMXBeanProxy(
                        ManagementFactory.getPlatformMBeanServer(),
                        HOTSPOT_BEAN_NAME,
                        HotSpotDiagnosticMXBean.class);
            }
        }
    }
}
